package com.unitesk.requality.eclipse.handlers;

import java.util.List;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;

import com.unitesk.requality.core.Attribute;
import com.unitesk.requality.core.AttributeType;
import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.ui.cnf.RequalityCNF;
import com.unitesk.requality.nodetypes.Requirement;

public class AddReferenceTo extends AbstractHandler {

    @Override
    public Object execute(ExecutionEvent event) throws ExecutionException {
        List<TreeNode> nodes = RequalityCNF.getSelectedNodes();
        nodes.get(0).getTreeDB().startTransaction("Add reference to requirement"+(nodes.size()>1?"s":""));
        for(TreeNode node:nodes){
        	TreeNode rnode = node.getTreeDB().getRefTarget();
            if(rnode!=null && node.getTreeDB().getRefTargetState(rnode)>0){
            	node.putAttribute(new Attribute(node.getUUId(),AttributeType.REFERENCE,node.getTreeDB().getDefReferenceName(), rnode.getUserFriendlyName()));
            	node.getLinkAttributeValue(node.getTreeDB().getDefReferenceName()).saveAttributes();;
            	node.saveAttributes();
            	if(node.getTreeDB().getRefTargetState(rnode)==1){
            		node.getTreeDB().setRefTarget(null);
            		node.getTreeDB().fireNodeGUIChange(rnode, true);
            	}
            }
        }
        nodes.get(0).getTreeDB().commit();
        return null;
    }
    @Override 
    public boolean isEnabled() {
        List<TreeNode> nodes = RequalityCNF.getSelectedNodes();
        if(!super.isEnabled())
        	return false;
        if(!nodes.get(0).getType().equals(Requirement.TYPE_NAME))
        	return false;
        TreeDB db = nodes.get(0).getTreeDB();
        for(TreeNode node:nodes)
        	if(!node.getTreeDB().equals(db) || !node.getType().equals(Requirement.TYPE_NAME))
        		return false;
        TreeNode rt = db.getRefTarget();
        return db.getRefTargetState(rt)>0;
    }
}
