package com.unitesk.requality.eclipse.handlers;

import java.util.List;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;


import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.ui.cnf.RequalityCNF;
import com.unitesk.requality.nodetypes.VirtualNode;

public class HideInstancerNode extends AbstractHandler {

    @Override
    public Object execute(ExecutionEvent event) throws ExecutionException {
        List<TreeNode> nodes = RequalityCNF.getSelectedNodes();
        if(nodes == null || nodes.size() < 1)
            return null;
        try{
        	nodes.get(0).getTreeDB().startTransaction("Hide selected elements");
			for(TreeNode node:nodes){
				if(!node.getType().equals(VirtualNode.TYPE_NAME))
					continue;
        		((VirtualNode)node).setHiddenState(true);
        		node.saveAttributes();
				node.getParent().getTreeDB().updateNodeChildren(node.getParent(true));
			}
			nodes.get(0).getTreeDB().commit();

        }
    	catch(Exception e){
 			nodes.get(0).getTreeDB().rollback();
    	}
		return null;
    }

    @Override
    public boolean isEnabled() {
        List<TreeNode> nodes = RequalityCNF.getSelectedNodes();
        if (nodes == null) {
            return false;
        }
        for(TreeNode node:nodes){
        	if (!node.getType().equals(VirtualNode.TYPE_NAME))
        		return false;
        }
        return true;
    }
}
